from time import sleep
import RPi.GPIO as GPIO

DIRR = 8  # Direction GPIO Pin (#8)
DIRL = 4  # Direction GPIO Pin (#8)
STEPR = 7  # Step GPIO Pin (#7)
STEPL = 14  # Step GPIO Pin (#7)
CW = 1     # Clockwise Rotation
CCW = 0    # Counterclockwise Rotation
SPR = 200   # Steps per Revolution (360 / 7.5)

def setup_GPIO() :
  GPIO.setmode(GPIO.BCM)
  GPIO.setup(DIRR, GPIO.OUT)
  GPIO.setup(DIRL, GPIO.OUT)

  GPIO.setup(STEPR, GPIO.OUT)
  GPIO.setup(STEPL, GPIO.OUT)
  
def cleanup_GPIO() :
  GPIO.cleanup()

delay = .005

def steps(value) :
  return int(value)
  
def cm(value) :
  return int(value/20.0*SPR)
  
def angle(value) :
  return (int)(value/100.0*SPR)
  
def drive(rdir, ldir, steps) :
  GPIO.output(DIRR, rdir)
  GPIO.output(DIRL, ldir)
  for x in range(steps):
    GPIO.output(STEPR, GPIO.HIGH)
    GPIO.output(STEPL, GPIO.HIGH)
    sleep(delay)
    GPIO.output(STEPR, GPIO.LOW)
    GPIO.output(STEPL, GPIO.LOW)
    sleep(delay)

def drive_forward(steps=SPR) :
  drive(CCW, CW, steps)

def drive_backward(steps=SPR) :
  drive(CW, CCW, steps)

def rotate_right(steps=SPR) :
  drive(CW, CW, steps)

def rotate_left(steps=SPR) :
  drive(CCW, CCW, steps)


def test_drive() : 
  drive_forward(steps(100))
  sleep(.5)
  drive_backward(steps(100))
  sleep(.5)

  drive_forward(cm(5))
  sleep(.5)
  drive_backward(cm(5))
  sleep(.5)

  rotate_right(angle(90))
  sleep(.5)
  rotate_left(angle(90))
  sleep(.5)
  rotate_left(angle(90))
  sleep(.5)
  rotate_right(angle(90))


if __name__ == "__main__":
  setup_GPIO()
  test_drive()
  cleanup_GPIO()

